﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RoomiezApp.Model
{
    public class Task
    {
        private int _id;
        private bool _isCompleted;
        public string Title;
        private string _description;
        private DateTime _deadline;
        public Roommate Assignee;
        private bool _done;

        public Task(int id, string name, string description, DateTime deadline, Roommate asignee, bool done)
        {
            _id = id;
            Title = name;
            _description = description;
            _deadline = deadline;
            Assignee= asignee;
            _done = done;
        }

        public void CompleteTask()
        {
            _isCompleted = false;
        }

        public string GetSummaryDeadlineString()
        {
            TimeSpan duration = _deadline - DateTime.Now;
            Debug.WriteLine("date" + _deadline);
            Debug.WriteLine(duration);
            int days = (int)duration.TotalDays;

            if (days < 0)
            {
                return "OVERDUE";
            }
            if (days == 0)
            {
                if (duration.TotalSeconds > 0)
                {
                    return "1d";
                }
                return "today";
            }

            StringBuilder dateString = new StringBuilder();

            int weeks = days / 7;
            if (weeks > 0)
            {
                dateString.Append($"{weeks}w ");
            }

            days = days % 7;
            if (days > 0)
            {
                dateString.Append($"{days}d");
            }

            return dateString.ToString().Trim();
        }
    }
}
